---
title: SpeechGrammarList.addFromString()
slug: Web/API/SpeechGrammarList/addFromString
tags:
  - API
  - Experimental
  - Method
  - Reference
  - SpeechGrammarList
  - Web Speech
  - addFromString
  - recognition
  - speech
---
<p>{{APIRef("Web Speech API")}}{{ SeeCompatTable() }}</p>

<p>The <code><strong>addFromString()</strong></code> method of the {{domxref("SpeechGrammarList")}} interface takes a grammar present in a specific {{domxref("DOMString")}} within the code base (e.g. stored in a variable) and adds it to the <code>SpeechGrammarList</code> as a new {{domxref("SpeechGrammar")}} object.</p>

<h2 id="Syntax">Syntax</h2>

<pre class="syntaxbox">speechGrammarListInstance.addFromString(string,weight);</pre>

<h3 id="Returns">Returns</h3>

<p>Void.</p>

<h3 id="Parameters">Parameters</h3>

<dl>
 <dt>string</dt>
 <dd>A {{domxref("DOMString")}} representing the grammar to be added.</dd>
 <dt>weight {{optional_inline}}</dt>
 <dd>A float representing the weight of the grammar relative to other grammars present in the {{domxref("SpeechGrammarList")}}. The weight means the importance of this grammar, or the likelihood that it will be recognised by the speech recognition service. The value can be between <code>0.0</code> and <code>1.0</code>; If not specified, the default used is <code>1.0</code>.</dd>
</dl>

<h2 id="Examples">Examples</h2>

<pre class="brush: js">var grammar = '#JSGF V1.0; grammar colors; public &lt;color&gt; = aqua | azure | beige | bisque | black | blue | brown | chocolate | coral | crimson | cyan | fuchsia | ghostwhite | gold | goldenrod | gray | green | indigo | ivory | khaki | lavender | lime | linen | magenta | maroon | moccasin | navy | olive | orange | orchid | peru | pink | plum | purple | red | salmon | sienna | silver | snow | tan | teal | thistle | tomato | turquoise | violet | white | yellow ;'
var recognition = new SpeechRecognition();
var speechRecognitionList = new SpeechGrammarList();
speechRecognitionList.addFromString(grammar, 1);
recognition.grammars = speechRecognitionList;
</pre>

<h2 id="Specifications">Specifications</h2>

<table class="standard-table">
 <tbody>
  <tr>
   <th scope="col">Specification</th>
   <th scope="col">Status</th>
   <th scope="col">Comment</th>
  </tr>
  <tr>
   <td>{{SpecName('Web Speech API', '#dom-speechgrammarlist-addfromstring', 'addFromString()')}}</td>
   <td>{{Spec2('Web Speech API')}}</td>
   <td></td>
  </tr>
 </tbody>
</table>

<h2 id="Browser_compatibility">Browser compatibility</h2>

<p>{{Compat("api.SpeechGrammarList.addFromString")}}</p>

<h3 id="Firefox_OS_permissions">Firefox OS permissions</h3>

<p>To use speech recognition in an app, you need to specify the following permissions in your <a href="/en-US/docs/Web/Apps/Build/Manifest">manifest</a>:</p>

<pre class="brush: json">"permissions": {
  "audio-capture" : {
    "description" : "Audio capture"
  },
  "speech-recognition" : {
    "description" : "Speech recognition"
  }
}</pre>

<p>You also need a privileged app, so you need to include this as well:</p>

<pre class="brush: json">  "type": "privileged"</pre>

<h2 id="See_also">See also</h2>

<ul>
 <li><a href="/en-US/docs/Web/API/Web_Speech_API">Web Speech API</a></li>
</ul>
